searchData={"items":[{"type":"module","title":"ExToolkit","doc":"[![hex.pm](https://img.shields.io/hexpm/v/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![hex.pm](https://img.shields.io/hexpm/dt/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![hex.pm](https://img.shields.io/hexpm/l/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![github.com](https://img.shields.io/github/last-commit/marmelasoft/ex_toolkit.svg)](https://github.com/marmelasoft/ex_toolkit)\n\n`ExToolkit` is a collection of Elixir helpers that offers pre-built effective\nrecipes for common needs when developing most applications.","ref":"ExToolkit.html"},{"type":"module","title":"Installation - ExToolkit","doc":"The package can be installed by adding `ex_toolkit` to your list of dependencies in\n`mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_toolkit, \"~> 0.9.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"ExToolkit.html#module-installation"},{"type":"module","title":"ExToolkit.Bench","doc":"Utility for quick and simple benchmarking functions in Elixir.","ref":"ExToolkit.Bench.html"},{"type":"macro","title":"ExToolkit.Bench.timeit/2","doc":"Benchmarks the execution time of a piece of code. It should be used only in\nreally simple cases.","ref":"ExToolkit.Bench.html#timeit/2"},{"type":"macro","title":"Examples - ExToolkit.Bench.timeit/2","doc":"iex> timeit \"Sleep for a while\", do: :timer.sleep(1000)\n  Executed Sleep for a while in 1.00 seconds","ref":"ExToolkit.Bench.html#timeit/2-examples"},{"type":"module","title":"ExToolkit.Ecto.Changeset","doc":"Helper functions that extend `Ecto.Changeset` functionality.","ref":"ExToolkit.Ecto.Changeset.html"},{"type":"function","title":"ExToolkit.Ecto.Changeset.validate_url/3","doc":"Validates the structure of a URL field in an Ecto changeset. It does not make it required field.\n\nIf the `field` in the `changeset` is a URL, this function ensures that it has a scheme (defaulting to \"https://\" if\nnone is present), and then checks the URL's structure against a regular expression.\n\nIf the URL's structure is invalid, the `error_message` is attached to the `field` in the `changeset`'s errors.","ref":"ExToolkit.Ecto.Changeset.html#validate_url/3"},{"type":"function","title":"Parameters - ExToolkit.Ecto.Changeset.validate_url/3","doc":"- `changeset`: The Ecto changeset containing the URL to validate.\n  - `field`: The key (atom) for the field in the changeset containing the URL.\n  - `error_message`: The error message to attach to the `field` in the `changeset` if the URL is invalid.","ref":"ExToolkit.Ecto.Changeset.html#validate_url/3-parameters"},{"type":"function","title":"Examples - ExToolkit.Ecto.Changeset.validate_url/3","doc":"iex> types = %{url: :string}\n    iex> params = %{url: \"https://www.example.com/\"}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset \n\n    iex> types = %{url: :string}\n    iex> params = %{url: \"www.example.com/\"}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset \n\n    iex> types = %{url: :string}\n    iex> params = %{url: nil}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset \n\n    iex> types = %{url: :string}\n    iex> params = %{url: \"some@invalid_url\"}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset \n\n    iex> types = %{url: :string}\n    iex> params = %{url: \"Just some random text\"}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset","ref":"ExToolkit.Ecto.Changeset.html#validate_url/3-examples"},{"type":"module","title":"ExToolkit.Ecto.ObjectID","doc":"A Ecto type that facilitates the generation of prefixed base62 encoded UUIDv7\nfor use as primary and foreign keys in Ecto schemas.","ref":"ExToolkit.Ecto.ObjectID.html"},{"type":"module","title":"Examples - ExToolkit.Ecto.ObjectID","doc":"@primary_key {:id, ExToolkit.Ecto.ObjectID, prefix: \"user\", autogenerate: true}\n    @foreign_key_type ExToolkit.Ecto.ObjectID","ref":"ExToolkit.Ecto.ObjectID.html#module-examples"},{"type":"module","title":"Resources - ExToolkit.Ecto.ObjectID","doc":"- https://dev.to/stripe/designing-apis-for-humans-object-ids-3o5a\n  - https://danschultzer.com/posts/prefixed-base62-uuidv7-object-ids-with-ecto","ref":"ExToolkit.Ecto.ObjectID.html#module-resources"},{"type":"type","title":"ExToolkit.Ecto.ObjectID.opts/0","doc":"","ref":"ExToolkit.Ecto.ObjectID.html#t:opts/0"},{"type":"type","title":"ExToolkit.Ecto.ObjectID.t/0","doc":"","ref":"ExToolkit.Ecto.ObjectID.html#t:t/0"},{"type":"module","title":"ExToolkit.Ecto.Query","doc":"A helper module that extend `Ecto.Query` functionality.","ref":"ExToolkit.Ecto.Query.html"},{"type":"function","title":"ExToolkit.Ecto.Query.apply_filters/2","doc":"","ref":"ExToolkit.Ecto.Query.html#apply_filters/2"},{"type":"function","title":"ExToolkit.Ecto.Query.apply_options/2","doc":"Applies a series of operations to an Ecto query.","ref":"ExToolkit.Ecto.Query.html#apply_options/2"},{"type":"function","title":"Parameters - ExToolkit.Ecto.Query.apply_options/2","doc":"- `query`: The Ecto query to which operations should be applied.\n- `opts`: A list of operations to apply. Each operation is a tuple where the first element is the operation name\n  and the second element is the value to use for that operation.\n\nThe following operations are supported:\n\n- `{:where, filters}`: Adds a `where` clause to the query.\n- `{:select, fields}`: Adds a `select` clause to the query.\n- `{:order_by, criteria}`: Adds an `order_by` clause to the query.\n- `{:limit, criteria}`: Adds a `limit` clause to the query.\n- `{:preload, preload}`: Adds a `preload` clause to the query.\n\nInvalid options are ignored from query result.","ref":"ExToolkit.Ecto.Query.html#apply_options/2-parameters"},{"type":"function","title":"Examples - ExToolkit.Ecto.Query.apply_options/2","doc":"iex> query = from(u in \"users\")\n    iex> apply_options(query, where: [age: 18], select: [:id, :email])\n    #Ecto.Query \n\n    iex> query = from(u in \"users\")\n    iex> filters = [\n    ...> {:where, [age: 18]},\n    ...> {:order_by, [desc: :age]},\n    ...> {:select, [:id, :email]},\n    ...> {:limit, 10},\n    ...> {:preload, :posts},\n    ...>]\n    iex> apply_options(query, filters)\n    #Ecto.Query","ref":"ExToolkit.Ecto.Query.html#apply_options/2-examples"},{"type":"function","title":"ExToolkit.Ecto.Query.apply_pagination/3","doc":"Applies pagination to an Ecto query. It calculates the correct offset based on the page number and limits the number\nof results returned by the query to the specified page size.","ref":"ExToolkit.Ecto.Query.html#apply_pagination/3"},{"type":"function","title":"Parameters - ExToolkit.Ecto.Query.apply_pagination/3","doc":"- `query` - An Ecto.Query or any data structure implementing the `Ecto.Queryable` protocol.\n  - `page` - The page number for which data is requested. Can be a positive integer or a string representing an integer.\n  - `page_size` - The number of items to be included on each page. Can be a positive integer or a string representing an integer.","ref":"ExToolkit.Ecto.Query.html#apply_pagination/3-parameters"},{"type":"function","title":"Returns - ExToolkit.Ecto.Query.apply_pagination/3","doc":"- An `Ecto.Queryable.t()` with pagination applied.\n\nThis function supports page and page_size values passed as integers or strings. If strings are provided, they are\nconverted to integers. If the conversion is not possible, an error will occur.","ref":"ExToolkit.Ecto.Query.html#apply_pagination/3-returns"},{"type":"function","title":"Examples - ExToolkit.Ecto.Query.apply_pagination/3","doc":"iex> query = from(u in \"users\", select: u.id)\n    iex> apply_pagination(query, 1, 20)\n    #Ecto.Query \n\n    iex> query = from(u in \"users\", select: u.id)\n    iex> apply_pagination(query, \"2\", 20)\n    #Ecto.Query \n\n    iex> query = from(u in \"users\", select: u.id)\n    iex> apply_pagination(query, 4, \"15\")\n    #Ecto.Query","ref":"ExToolkit.Ecto.Query.html#apply_pagination/3-examples"},{"type":"function","title":"ExToolkit.Ecto.Query.in_range/3","doc":"Filters a query to only include rows where the specified column's value is within a provided range.","ref":"ExToolkit.Ecto.Query.html#in_range/3"},{"type":"function","title":"Parameters - ExToolkit.Ecto.Query.in_range/3","doc":"- `query`: The Ecto query to filter.\n- `column`: The column on which to apply the range filter.\n- `min..max`: The range of values to filter on.","ref":"ExToolkit.Ecto.Query.html#in_range/3-parameters"},{"type":"function","title":"Examples - ExToolkit.Ecto.Query.in_range/3","doc":"iex> query = from(u in \"users\", select: u.age)\n    iex> in_range(query, :age, 18..30)\n    #Ecto.Query = ^18 and u0.age <= ^30, select: u0.age>","ref":"ExToolkit.Ecto.Query.html#in_range/3-examples"},{"type":"function","title":"ExToolkit.Ecto.Query.sanitize_options/1","doc":"","ref":"ExToolkit.Ecto.Query.html#sanitize_options/1"},{"type":"module","title":"ExToolkit.Ecto.SlugID","doc":"A Ecto type that facilitates the generation of prefixed base62 encoded UUIDv7\nfor use as primary and foreign keys in Ecto schemas.","ref":"ExToolkit.Ecto.SlugID.html"},{"type":"module","title":"Examples - ExToolkit.Ecto.SlugID","doc":"@primary_key {:id, ExToolkit.Ecto.SlugID, autogenerate: true}\n    @foreign_key_type ExToolkit.Ecto.SlugID","ref":"ExToolkit.Ecto.SlugID.html#module-examples"},{"type":"function","title":"ExToolkit.Ecto.SlugID.generate/0","doc":"","ref":"ExToolkit.Ecto.SlugID.html#generate/0"},{"type":"type","title":"ExToolkit.Ecto.SlugID.t/0","doc":"","ref":"ExToolkit.Ecto.SlugID.html#t:t/0"},{"type":"module","title":"ExToolkit.Encode.Base62UUID","doc":"A utility module providing functions to encode and decode UUIDs using Base62 encoding.\n\nThe Base62 encoding allows representing UUIDs in a more compact form, reducing their length from 32 to 22 characters.\nThis module supports converting standard UUIDs (as strings) to Base62 encoded UUIDs and vice-versa.","ref":"ExToolkit.Encode.Base62UUID.html"},{"type":"function","title":"ExToolkit.Encode.Base62UUID.decode/1","doc":"Decodes a Base62 encoded string into a UUID.\n\nThis function is the inverse of `encode/1`. It converts a Base62 encoded string back to its original UUID form.","ref":"ExToolkit.Encode.Base62UUID.html#decode/1"},{"type":"function","title":"Examples - ExToolkit.Encode.Base62UUID.decode/1","doc":"iex> Base62UUID.decode(\"2FJ5BAFmLzL78YNqBSsS9I\")\n    {:ok, \"49d3793a-2f87-4bcb-aa96-be5892848ae0\"}","ref":"ExToolkit.Encode.Base62UUID.html#decode/1-examples"},{"type":"function","title":"ExToolkit.Encode.Base62UUID.encode/1","doc":"Encodes a UUID into a Base62 encoded string.","ref":"ExToolkit.Encode.Base62UUID.html#encode/1"},{"type":"function","title":"Examples - ExToolkit.Encode.Base62UUID.encode/1","doc":"iex> Base62UUID.encode(\"49d3793a-2f87-4bcb-aa96-be5892848ae0\")\n    \"2FJ5BAFmLzL78YNqBSsS9I\"","ref":"ExToolkit.Encode.Base62UUID.html#encode/1-examples"},{"type":"module","title":"ExToolkit.Git","doc":"This module provides utility functions for interacting with Git.","ref":"ExToolkit.Git.html"},{"type":"function","title":"ExToolkit.Git.revision_hash/0","doc":"Retrieves the current Git revision hash.","ref":"ExToolkit.Git.html#revision_hash/0"},{"type":"module","title":"ExToolkit.Naming","doc":"This module encapsulates common tasks related to processing personal names in\na standardized format. This module treats names as case-insensitive and\nreturns results in a formatted, readable way.","ref":"ExToolkit.Naming.html"},{"type":"function","title":"ExToolkit.Naming.capitalize/1","doc":"Capitalizes the first letter of each word in a name.","ref":"ExToolkit.Naming.html#capitalize/1"},{"type":"function","title":"Parameters - ExToolkit.Naming.capitalize/1","doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#capitalize/1-parameters"},{"type":"function","title":"Examples - ExToolkit.Naming.capitalize/1","doc":"iex> Naming.capitalize(nil)\n    \"\"\n\n    iex> Naming.capitalize(\"\")\n    \"\"\n\n    iex> Naming.capitalize(\"john doe\")\n    \"John Doe\"\n\n    iex> Naming.capitalize(\"JOHN DOE\")\n    \"John Doe\"\n\n    iex> Naming.capitalize(\"john nommensen duchac\")\n    \"John Nommensen Duchac\"","ref":"ExToolkit.Naming.html#capitalize/1-examples"},{"type":"function","title":"ExToolkit.Naming.extract_first_last_name/1","doc":"Extracts and capitalizes the first and last names from a given name.","ref":"ExToolkit.Naming.html#extract_first_last_name/1"},{"type":"function","title":"Parameters - ExToolkit.Naming.extract_first_last_name/1","doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#extract_first_last_name/1-parameters"},{"type":"function","title":"Examples - ExToolkit.Naming.extract_first_last_name/1","doc":"iex> Naming.extract_first_last_name(nil)\n    \"\"\n\n    iex> Naming.extract_first_last_name(\"\")\n    \"\"\n\n    iex> Naming.extract_first_last_name(\"john\")\n    \"John\"\n\n    iex> Naming.extract_first_last_name(\"john doe smith\")\n    \"John Smith\"","ref":"ExToolkit.Naming.html#extract_first_last_name/1-examples"},{"type":"function","title":"ExToolkit.Naming.extract_initials/1","doc":"Extracts the initials from a given name.\n\nThis function takes a name (a string of one or more words), and extracts the\nfirst letter of the first name and the family name.","ref":"ExToolkit.Naming.html#extract_initials/1"},{"type":"function","title":"Parameters - ExToolkit.Naming.extract_initials/1","doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#extract_initials/1-parameters"},{"type":"function","title":"Examples - ExToolkit.Naming.extract_initials/1","doc":"iex> Naming.extract_initials(nil)\n    \"\"\n\n    iex> Naming.extract_initials(\"\")\n    \"\"\n\n    iex> Naming.extract_initials(\"John\")\n    \"J\"\n\n    iex> Naming.extract_initials(\"John Doe\")\n    \"JD\"\n\n    iex> Naming.extract_initials(\"John Nommensen Duchac\")\n    \"JD\"","ref":"ExToolkit.Naming.html#extract_initials/1-examples"},{"type":"function","title":"ExToolkit.Naming.shorten_firstname/1","doc":"Shortens the first name to its initial, while preserving the rest of the name.\n\nThis function takes a name (a string of one or more words), and reduces the first name to its initial.\nThe rest of the name is preserved. The initial is followed by a period and a space, and then the rest of the name.","ref":"ExToolkit.Naming.html#shorten_firstname/1"},{"type":"function","title":"Parameters - ExToolkit.Naming.shorten_firstname/1","doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#shorten_firstname/1-parameters"},{"type":"function","title":"Examples - ExToolkit.Naming.shorten_firstname/1","doc":"iex> Naming.shorten_firstname(nil)\n    \"\"\n\n    iex> Naming.shorten_firstname(\"\")\n    \"\"\n\n    iex> Naming.shorten_firstname(\"John\")\n    \"J.\"\n\n    iex> Naming.shorten_firstname(\"john\")\n    \"J.\"\n\n    iex> Naming.shorten_firstname(\"John Doe\")\n    \"J. Doe\"\n\n    iex> Naming.shorten_firstname(\"john doe\")\n    \"J. Doe\"\n\n    iex> Naming.shorten_firstname(\"john doe jr\")\n    \"J. Doe Jr\"","ref":"ExToolkit.Naming.html#shorten_firstname/1-examples"},{"type":"extras","title":"Elixir Toolkit","doc":"# Elixir Toolkit\n\n[![hex.pm](https://img.shields.io/hexpm/v/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![hex.pm](https://img.shields.io/hexpm/dt/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![hex.pm](https://img.shields.io/hexpm/l/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![github.com](https://img.shields.io/github/last-commit/marmelasoft/ex_toolkit.svg)](https://github.com/marmelasoft/ex_toolkit)\n\n`ExToolkit` is a collection of Elixir helpers that offers pre-built effective\nrecipes for common needs when developing most applications.","ref":"readme.html"},{"type":"extras","title":"Installation - Elixir Toolkit","doc":"The package can be installed by adding `ex_toolkit` to your list of dependencies in\n`mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_toolkit, \"~> 0.9.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}